"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _bind = _interopRequireDefault(require("classnames/bind"));
var _terraThemeContext = _interopRequireDefault(require("terra-theme-context"));
var _reactRouterDom = require("react-router-dom");
var KeyCode = _interopRequireWildcard(require("keycode-js"));
var _ApplicationTabsModule = _interopRequireDefault(require("./ApplicationTabs.module.scss"));
var _excluded = ["externalLink", "history", "location", "onTabClick", "path", "text", "icon"];
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function _callSuper(t, o, e) { return o = (0, _getPrototypeOf2.default)(o), (0, _possibleConstructorReturn2.default)(t, _isNativeReflectConstruct() ? Reflect.construct(o, e || [], (0, _getPrototypeOf2.default)(t).constructor) : o.apply(t, e)); }
function _isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
var cx = _bind.default.bind(_ApplicationTabsModule.default);
var propTypes = {
  /**
   * The optional external link. Executes on window.open();
   */
  externalLink: _propTypes.default.shape({
    path: _propTypes.default.string.isRequired,
    target: _propTypes.default.string
  }),
  /**
   * The history as provided by the `withRouter()` HOC.
   */
  history: _propTypes.default.object.isRequired,
  /**
   * The location as provided by the `withRouter()` HOC.
   */
  location: _propTypes.default.object.isRequired,
  /**
   * The path to push to the route.
   */
  path: _propTypes.default.string.isRequired,
  /**
   * The display text for the tab.
   */
  text: _propTypes.default.string.isRequired,
  /**
   * The click callback of the tab.
   */
  onTabClick: _propTypes.default.func,
  /**
   * The display icon for the tab
   */
  icon: _propTypes.default.node
};
var CollapseTab = /*#__PURE__*/function (_Component) {
  function CollapseTab(props) {
    var _this;
    (0, _classCallCheck2.default)(this, CollapseTab);
    _this = _callSuper(this, CollapseTab, [props]);
    _this.state = {
      active: false,
      focused: false
    };
    _this.handleOnClick = _this.handleOnClick.bind(_this);
    _this.handleKeyDown = _this.handleKeyDown.bind(_this);
    _this.handleKeyUp = _this.handleKeyUp.bind(_this);
    _this.handleOnBlur = _this.handleOnBlur.bind(_this);
    _this.isCurrentPath = _this.isCurrentPath.bind(_this);
    return _this;
  }
  (0, _inherits2.default)(CollapseTab, _Component);
  return (0, _createClass2.default)(CollapseTab, [{
    key: "handleOnBlur",
    value: function handleOnBlur() {
      this.setState({
        focused: false
      });
    }
  }, {
    key: "handleKeyDown",
    value: function handleKeyDown(event) {
      // Add active state to FF browsers
      if (event.nativeEvent.keyCode === KeyCode.KEY_SPACE) {
        this.setState({
          active: true
        });
      }

      // Add focus styles for keyboard navigation
      if (event.nativeEvent.keyCode === KeyCode.KEY_SPACE || event.nativeEvent.keyCode === KeyCode.KEY_RETURN) {
        this.setState({
          focused: true
        });
        event.preventDefault();
        this.handleOnClick(event);
      }
    }
  }, {
    key: "handleKeyUp",
    value: function handleKeyUp(event) {
      // Remove active state from FF broswers
      if (event.nativeEvent.keyCode === KeyCode.KEY_SPACE) {
        this.setState({
          active: false
        });
      }

      // Apply focus styles for keyboard navigation
      if (event.nativeEvent.keyCode === KeyCode.KEY_TAB) {
        event.preventDefault();
        event.stopPropagation();
        this.setState({
          focused: true
        });
      }
    }
  }, {
    key: "handleOnClick",
    value: function handleOnClick(event) {
      if (this.props.externalLink) {
        window.open(this.props.externalLink.path, this.props.externalLink.target || '_blank');
        if (this.props.onTabClick) {
          this.props.onTabClick(event);
        }
        return;
      }
      if (!this.isCurrentPath()) {
        this.props.history.push(this.props.path);
      } else if (this.props.onTabClick) {
        this.props.onTabClick(event);
      }
    }
  }, {
    key: "isCurrentPath",
    value: function isCurrentPath() {
      return !!(0, _reactRouterDom.matchPath)(this.props.location.pathname, {
        path: this.props.path
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
        externalLink = _this$props.externalLink,
        history = _this$props.history,
        location = _this$props.location,
        onTabClick = _this$props.onTabClick,
        path = _this$props.path,
        text = _this$props.text,
        icon = _this$props.icon,
        customProps = (0, _objectWithoutProperties2.default)(_this$props, _excluded);
      var _this$state = this.state,
        active = _this$state.active,
        focused = _this$state.focused;
      var isCurrent = this.isCurrentPath();
      var hasIcon = !!icon;
      var theme = this.context;
      var tabClassNames = (0, _classnames.default)(cx('collapsed-tab', {
        'collapsed-tab-with-icon': hasIcon
      }, {
        'is-active': active
      }, {
        'is-focused': focused
      }, theme.className), customProps.className);
      var tabAttr = {
        'aria-current': isCurrent
      };

      /* eslint-disable jsx-a11y/no-noninteractive-tabindex */
      /* eslint-disable jsx-a11y/no-noninteractive-element-interactions */
      return /*#__PURE__*/_react.default.createElement("li", (0, _extends2.default)({}, customProps, tabAttr, {
        tabIndex: "0",
        className: tabClassNames,
        onClick: this.handleOnClick,
        onKeyDown: this.handleKeyDown,
        onKeyUp: this.handleKeyUp,
        onBlur: this.handleOnBlur
      }), /*#__PURE__*/_react.default.createElement("div", {
        role: "link",
        className: cx('tab-inner')
      }, icon && /*#__PURE__*/_react.default.createElement("span", {
        className: cx('collapsed-tab-icon')
      }, icon), /*#__PURE__*/_react.default.createElement("span", {
        className: cx('tab-label')
      }, text)));
    }
  }]);
}(_react.Component);
CollapseTab.propTypes = propTypes;
CollapseTab.contextType = _terraThemeContext.default;
var _default = exports.default = CollapseTab;